﻿window.onload = function () {
    var app = new Vue({
        el: '#app',
        data: {
        }
    });
};

Vue.component('manual_record_modal', {
    data: function () {
        return {
            listing: "",
            existingRecurring: null
        };
    },    
    template: '<div class="modal fade" id="manualRecordModal" tabindex="-1" role="dialog" aria-labelledby="manualRecordModalLabel" aria-hidden="true">\
                    <div class= "modal-dialog modal-lg" role="document" >\
                        <div class="modal-content">\
                            <div class="modal-header">\
                                <h5 class="modal-title" id="manualRecordModalTitle">Modal title</h5>\
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">\
                                    <span aria-hidden="true">&times;</span>\
                                </button>\
                            </div>\
                            <div class="modal-body">\
                                <div class="row">\
                                    <div class="col-12">\
                                        <p id="manualRecordModalPeriod" class="text-light"></p>\
                                    </div>\
                                </div>\
                                <div class="row">\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="advancedName">Recording Name:</label>\
                                            <input id="advancedName" type="text" value="default" class="form-control col-lg-6 col-sm-7" data-container="body"></input>\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="advancedChannelSelector">Channel:</label>\
                                            <select id="advancedChannelSelector" class="custom-select col-lg-6 col-sm-7" data-container="body">\
                                            </select>\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="name">Date / Time:</label>\
                                            <input type="text" class="form-control datetimepicker-input col-lg-6 col-sm-7" id="datetimepicker5" data-toggle="datetimepicker" data-target="#datetimepicker5" />\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="name">Recording Type:</label>\
                                            <select id="advancedType" class="custom-select col-lg-6 col-sm-7" data-container="body">\
                                                <option value="once">Record Once</option>\
                                                <option value="3">Record Daily</option>\
                                                <option value="4">Record Weekly</option>\
                                                <option value="5">Record Week Days (Monday-Friday)</option>\
                                                <option value="6">Record Weekends (Saturday/Sunday)</option>\
                                            </select>\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="name">Pre-Padding:</label>\
                                            <select id="advancedPrePadding" class="custom-select col-lg-6 col-sm-7" data-container="body">\
                                                <option value="default">Default</option>\
                                                <option value="1">1</option>\
                                                <option value="2">2</option>\
                                                <option value="3">3</option>\
                                                <option value="4">4</option>\
                                                <option value="5">5</option>\
                                                <option value="6">6</option>\
                                                <option value="7">7</option>\
                                                <option value="8">8</option>\
                                                <option value="9">9</option>\
                                                <option value="10">10</option>\
                                                <option value="11">11</option>\
                                                <option value="12">12</option>\
                                                <option value="13">13</option>\
                                                <option value="14">14</option>\
                                                <option value="15">15</option>\
                                                <option value="16">16</option>\
                                                <option value="17">17</option>\
                                                <option value="18">18</option>\
                                                <option value="19">19</option>\
                                                <option value="20">20</option>\
                                                <option value="21">21</option>\
                                                <option value="22">22</option>\
                                                <option value="23">23</option>\
                                                <option value="24">24</option>\
                                                <option value="25">25</option>\
                                                <option value="26">26</option>\
                                                <option value="27">27</option>\
                                                <option value="28">28</option>\
                                                <option value="29">29</option>\
                                                <option value="30">30</option>\
                                                <option value="31">31</option>\
                                                <option value="32">32</option>\
                                                <option value="33">33</option>\
                                                <option value="34">34</option>\
                                                <option value="35">35</option>\
                                                <option value="36">36</option>\
                                                <option value="37">37</option>\
                                                <option value="38">38</option>\
                                                <option value="39">39</option>\
                                                <option value="40">40</option>\
                                                <option value="41">41</option>\
                                                <option value="42">42</option>\
                                                <option value="43">43</option>\
                                                <option value="44">44</option>\
                                                <option value="45">45</option>\
                                                <option value="46">46</option>\
                                                <option value="47">47</option>\
                                                <option value="48">48</option>\
                                                <option value="49">49</option>\
                                                <option value="50">50</option>\
                                                <option value="51">51</option>\
                                                <option value="52">52</option>\
                                                <option value="53">53</option>\
                                                <option value="54">54</option>\
                                                <option value="55">55</option>\
                                                <option value="56">56</option>\
                                                <option value="57">57</option>\
                                                <option value="58">58</option>\
                                                <option value="59">59</option>\
                                                <option value="60">60</option>\
                                            </select>\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="name">Post-Padding:</label>\
                                            <select id="advancedPostPadding" class="custom-select col-lg-6 col-sm-7" data-container="body">\
                                                <option value="default">Default</option>\
                                                <option value="1">1</option>\
                                                <option value="2">2</option>\
                                                <option value="3">3</option>\
                                                <option value="4">4</option>\
                                                <option value="5">5</option>\
                                                <option value="6">6</option>\
                                                <option value="7">7</option>\
                                                <option value="8">8</option>\
                                                <option value="9">9</option>\
                                                <option value="10">10</option>\
                                                <option value="11">11</option>\
                                                <option value="12">12</option>\
                                                <option value="13">13</option>\
                                                <option value="14">14</option>\
                                                <option value="15">15</option>\
                                                <option value="16">16</option>\
                                                <option value="17">17</option>\
                                                <option value="18">18</option>\
                                                <option value="19">19</option>\
                                                <option value="20">20</option>\
                                                <option value="21">21</option>\
                                                <option value="22">22</option>\
                                                <option value="23">23</option>\
                                                <option value="24">24</option>\
                                                <option value="25">25</option>\
                                                <option value="26">26</option>\
                                                <option value="27">27</option>\
                                                <option value="28">28</option>\
                                                <option value="29">29</option>\
                                                <option value="30">30</option>\
                                                <option value="31">31</option>\
                                                <option value="32">32</option>\
                                                <option value="33">33</option>\
                                                <option value="34">34</option>\
                                                <option value="35">35</option>\
                                                <option value="36">36</option>\
                                                <option value="37">37</option>\
                                                <option value="38">38</option>\
                                                <option value="39">39</option>\
                                                <option value="40">40</option>\
                                                <option value="41">41</option>\
                                                <option value="42">42</option>\
                                                <option value="43">43</option>\
                                                <option value="44">44</option>\
                                                <option value="45">45</option>\
                                                <option value="46">46</option>\
                                                <option value="47">47</option>\
                                                <option value="48">48</option>\
                                                <option value="49">49</option>\
                                                <option value="50">50</option>\
                                                <option value="51">51</option>\
                                                <option value="52">52</option>\
                                                <option value="53">53</option>\
                                                <option value="54">54</option>\
                                                <option value="55">55</option>\
                                                <option value="56">56</option>\
                                                <option value="57">57</option>\
                                                <option value="58">58</option>\
                                                <option value="59">59</option>\
                                                <option value="60">60</option>\
                                            </select>\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="name">Directory:</label>\
                                            <select id="advancedDirectory" class="custom-select col-lg-6 col-sm-7" data-container="body">\
                                                <option value="default">Default</option>\
                                            </select>\
                                        </div>\
                                    </div>\
                                    <div class="form-inline col-12">\
                                        <div class="col-12 form-group extra-vertical">\
                                            <label class="col-lg-3 col-sm-5 col-form-label font-weight-bold" for="name">Keep:</label>\
                                            <select id="advancedKeep" class="custom-select col-lg-6 col-sm-7" data-container="body">\
                                                <option value="0">All</option>\
                                                <option value="1">1</option>\
                                                <option value="2">2</option>\
                                                <option value="3">3</option>\
                                                <option value="4">4</option>\
                                                <option value="5">5</option>\
                                                <option value="6">6</option>\
                                                <option value="7">7</option>\
                                                <option value="8">8</option>\
                                                <option value="9">9</option>\
                                                <option value="10">10</option>\
                                                <option value="11">11</option>\
                                                <option value="12">12</option>\
                                                <option value="13">13</option>\
                                                <option value="14">14</option>\
                                                <option value="15">15</option>\
                                                <option value="16">16</option>\
                                                <option value="17">17</option>\
                                                <option value="18">18</option>\
                                                <option value="19">19</option>\
                                                <option value="20">20</option>\
                                            </select>\
                                        </div>\
                                    </div>\
                                </div>\
                            </div>\
                            <div class="modal-footer">\
                                <button type="button" class="btn btn-danger" @click="save()" data-dismiss="modal">Save</button>\
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>\
                            </div>\
                        </div>\
                    </div>\
               </div>',
    mounted: function () {
        var self = this;   
        self.loaded = false;
    },
    methods: {
        show() {
            //this.listing = listing;
            this.existingRecurring = null;

            var currentTime = (new Date()).getTime() / 1000;

            $('#manualRecordModalTitle').text("Add Manual Recording");                

            $('#advancedType').val(2);
            $('#advancedPrePadding').val('default');
            $('#advancedPostPadding').val('default');
            $('#advancedKeep').val('0');
            $('#advancedDirectory').val('default');
            //$('#advancedChannel').val('this-channel');
            
            // load date
            $('#datetimepicker5').datetimepicker();
            /*
            var selectedDate = new Date();
            for (var day = 2; day < 60; day++) {
                var dateOption = new Date(selectedDate);
                dateOption.setDate(dateOption.getDate() + day);
                $('#advancedDate').append('<option value="' + day + '">' + dateOption.toDateString() + '</option>');
            }*/

            
            // load channel list
            $('#advancedChannel').empty();
            var url = 'services/service?method=channel.list';
            var preferredChannelGroup = localStorage.getItem('preferredChannelGroup');
            if (preferredChannelGroup !== null) {
                url += "&group_id=" + encodeURIComponent(preferredChannelGroup);
            }
            $.getJSON(url, function (data) {
                // default to empty current show name
                data.channels.forEach(function (channel) {
                    $('#advancedChannelSelector').append('<option value="' + channel.channelId + '">' + channel.channelName + '</option>');
                });
            });
            /*
            // period
            var episodeStartTime = new Date(listing.start * 1000);
            var episodeEndTime = new Date(listing.end * 1000);
            var period = '' + episodeStartTime.toLocaleDateString() + '  ' + episodeStartTime.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' }) + ' - ' + episodeEndTime.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
            $('#manualRecordModalPeriod').text(period);       
            */
            
            // determine appropriate buttons to show
            $('#cancelButton').hide();
            /*
            // only show watch button for shows currently airing
            if (listing.start <= currentTime && listing.end >= currentTime) {
                $('#watchButton').show();
            }
            

            // only show record button for shows not already scheduled
            if (typeof listing.recording_id === 'undefined') {
                var now = new Date();
                if (episodeEndTime >= now) {
                    $('#recordOnceButton').show();
                    $('#recordSeriesButton').show();
                    $('#recordAdvancedButton').show();
                }                
            } else {
                // only show cancel button for shows already scheduled
                $('#cancelButton').show();
            }           
            */
            $('#recordOnceButton').show();

            // show modal
            $('#manualRecordModal').modal('show');         

            // reinitialize bootstrap-select
            //$('.selectpicker').selectpicker();
        },
        edit(recurring) {            
            this.existingRecurring = recurring;
            this.listing = null;
            // show modal
            $('#manualRecordModalTitle').text(recurring.name);
            $('#advancedType').val(recurring.type);
            $('#advancedPrePadding').val(recurring.prePadding);
            $('#advancedPostPadding').val(recurring.postPadding);
            $('#advancedKeep').val(recurring.keep);

            if (recurring.channelID == 0) {
                $('#advancedChannel').val('all-channels');
            }
            else {
                $('#advancedChannel').val('this-channel');
            }

            $('#manualRecordModal').modal('show');
        },
        save() {
            // build up recording request
            var url = "services/service?method=recording.save";        

            // handle recurring
            if ($('#advancedType').val() != "once") {                
                url = "services/service?method=recording.recurring.save";
                url += "&recurring_type=" + $('#advancedType').val()

                // keep
                if ($('#advancedKeep').val() != "all") {
                    url += "&keep=" + $('#advancedKeep').val();
                }                
            }

            if (this.existingRecurring != null) {
                // recurring id
                url += "&recurring_id=" + this.existingRecurring.id;
            } else {
                // event
                url += "&event_id=" + this.listing.id;
            }

            // pre-padding
            if ($('#advancedPrePadding').val() != "default") {
                url += "&pre_padding=" + $('#advancedPrePadding').val();
            }
            // post-padding
            if ($('#advancedPostPadding').val() != "default") {
                url += "&post_padding=" + $('#advancedPostPadding').val();
            }

            // directory
            if ($('#directory_id').val() != "default") {
                url += "&directory_id=" + $('#advancedDirectory').val();
            }

            url += "&format=json";
            
            // schedule recording            
            $.ajax({
                url: url,
                crossDomain: true,
                type: 'get',
                async: true,
                success: function (response, textStatus, xhr) {
                    if (response.stat === "ok") {
                        console.log('Advanced record successful');
                        reloadRecordings();                        
                    } else { 
                        //alert("Failed to schedule recording\n\n" + response.msg);
                        showMessage("Scheduling Error", response.msg);
                    }
                },
                error: function (xhr, textStatus, errorThrown) {
                    var message = "Unable to schedule recording at this time. ";
                    if ((xhr.readyState == 4 || xhr.readyState == 0) && xhr.status == 0) {
                        message += "Unable to connect to server.";
                    }
                    showMessage("Scheduling Error", message);                    
                }
            });            
        }        
    }
});
